!=====================================================================!
      subroutine cyltosph(lpr)
!=====================================================================!
!     calculate the expansion coefficients
!     of s.p. states on spherical oscillator basis
!     pay attention to fibc()
!---------------------------------------------------------------------! 
!Use Definitions
!Use MeanField
c      Implicit None
!
      implicit real*8 (a-h,o-z)
      include 'dirhb.par'
      Logical lpr
      Integer il,ib,it,k1,k2,ibsp,k,ndsp,i0sp,nfgsp
      Integer nfg,nnsp,klp1,l
      Integer nl1,nr1,nj1,nm1,ifg,nd,i0,n,nz2,nr2,ml2,nss2,nncyl,kk
      Real*8 ormsphfg(nkx,nbx,2), fgs(nh2x,nkx,4) ! nh2x = nt2x 
      Real*8 stest,sm,coef
      Real*8 external transsph
      character tb*6    

      common /fermi / ala(2),tz(2)
      common /eeecan/ eecan(KX,4),decan(KX,4),vvcan(KX,4),
     &                fgcan(NHX,KX,4),ibkcan(KX,4)
      common /quaosc/ nt,nz(NTX),nr(NTX),ml(NTX),ms(NTX),np(NTX),tt(NTX)
      common /blodir/ ka(NBX,4),kd(NBX,4)
      common /blokap/ nb,kb(NBX),mb(NBX),tb(NBX)
      common/basesph1/nljm(nt2x,4),idsp(2,2),iasp(2,2)
      common /kblock/ kblocs(2)
      common /basesph2/ fgsph(nh2x,nkx,4),kasp(nbx,4),kdsp(nbx,4)
      common /basesph3/ vvs(nkx,4),ees(nkx,4),delss(nkx,4),
     & fss(nkx,4),eqps(nkx,4)
      common /bloosc/ ia(NBX,2),id(NBX,2)
      common /blocan/ kacan(nbx,4),kdcan(nbx,4),nkcan(2)
!******************************************************************cc 
      if (lpr) 
     &write(l6,*) ' ******  BEGIN TRANSFORMATION*******************'
!---------- loop over neutrons and protons
            do it = 1,2
!---- loop over K and parity-blocks
               write(*,*)'nb',nb
            do ib = 1,nb               
               k1 = ka(ib,it) + 1        
               k2 = ka(ib,it) + kd(ib,it)
               write(*,*) 'it=',it,'ib=',ib,'ka=',ka(ib,it),
     &         'kd=',kd(ib,it),kacan(ib,it),kdcan(ib,it)
!-------------------------------------------------------------
!           kb(ib)>0 (positive parity);<0 (negative parity)
!-------------------------------------------------------------
               if(kb(ib).gt.0) ibsp=1
               if(kb(ib).lt.0) ibsp=2
!---------- loop over S.P.States
            do k = k1,k2
!------- loop over contributions from large and small components
            stest = 0 
            do ifg = 1,2
!-----------the block of spher. HO basis states 
            ndsp  = idsp(ibsp,ifg)
            i0sp  = iasp(ibsp,ifg)
            nfgsp = (ifg-1)*idsp(ibsp,1)
!
            nd  = id(ib,ifg)
            i0  = ia(ib,ifg)
            nfg = (ifg-1)*id(ib,1)  
!---------- loop of spher. oscillator basis states------------
            do il=1,ndsp
               nr1 = nljm(i0sp+il,1)
               nl1 = nljm(i0sp+il,2)
               nj1 = nljm(i0sp+il,3)
               nm1 = nljm(i0sp+il,4) 
               nnsp= 2*(nr1-1) + nl1 
               sm= 0.d0
!              if (abs(nm1).ne.abs(kb(ib))) goto 112
!---------- loop of oscillator basis states n
               do n = 1,nd 
                  nz2 = nz(n+i0)
                  nr2 = nr(n+i0)
                  ml2 = ml(n+i0)
                  nss2= ms(n+i0)  ! 0(down); 1(up)
                  nncyl= nz2 + 2*nr2 + ml2
!          if(il.eq.2) stest = stest + fg(nfg+n,k,it)*fg(nfg+n,k,it)
!----------------------------------------------------
!           nss2 + ml2 = abs(kb(ib)) = Omega > 0
!---------------------------------------------------
c                  print *, 'nn',nncyl,nnsp
                  if(nncyl.ne.nnsp)    goto 110  
!---------------------------------------------------
                  coef = transsph(nz2,nr2,ml2,nss2,nr1,nl1,nj1,nm1) 
!                  sm   = sm + wfg(k,nfg+n,it)*coef           
c                  print *, nz2,nr2,ml2,nss2,nr1,nl1,nj1,nm1,coef
c                  pause
                  sm   = sm + fgcan(nfg+n,k,it)*coef   ! no anti-particles
c                  print *, 'fgcan',n,k,it,nit,fgcan(n,k,nit+it),coef   
  110      enddo !n
  112      continue 
!-----------------------------------
              fgs(nfgsp+il,k,it) = sm 
              stest = stest + fgs(nfgsp+il,k,it)**2
!-----------------------------------
  250      enddo      ! il 
!------- end loop over large and small components
           enddo   ! ifg
!--------end loop over s.p. states
           print *, 'stest=', stest 
           enddo !k
!------- end loop over blocks ib
  115      enddo   ! ib
!--------end loop over neutron and proton
           enddo   ! it
  120       format(a,i4,i1,i1,a,f10.5)
  130       format(a,i3,a,i1,a,i1,a,2f12.8)
  140       format(a)
!==============================================================
!
!    combining all the s.p. states according to their parity
!
!==============================================================
!---------- loop over neutrons and protons 
        do it = 1,2
!----------------------
         kblocs(it) = 0 
         klp1      = 0 
         kasp(1,it)= 0
!---- loop over K and parity-blocks
        do ib = 1,nb          
!-------------------------------------------------------------
!           kb(ib)>0 (positive parity);<0 (negative parity)
!-------------------------------------------------------------
          if(kb(ib).gt.0) then     
          ibsp = 1 
          k1   = ka(ib,it) + 1        
          k2   = ka(ib,it) + kd(ib,it) 
!---------- loop over S.P.States
              do k = k1,k2 
              klp1 = klp1+1
c              If(ib.eq.kkbloc(it).and.k.eq.kibloc(it)) then
c                kblocs(it) = klp1
c              endif
              vvs(klp1,it)=vvcan(k,it)
              ees(klp1,it)=eecan(k,it)
              delss(klp1,it)=decan(k,it)
!              fss(klp1,it)=fs(k,it)
              eqps(klp1,it)=dsqrt((eecan(k,it)-ala(it))**2
     &       +decan(k,it)**2)
!------- loop over contributions from large and small components
!             stest = 0.d0
                 do ifg = 1,2
!-----------the block of spher. HO basis states 
                    ndsp = idsp(ibsp,ifg)
                    nfgsp= (ifg-1)*idsp(ibsp,1)
!---------- loop of spher. oscillator basis states------------
                 do il=1,ndsp
                    fgsph(nfgsp+il,klp1,it)=fgs(nfgsp+il,k,it)
!                   stest = stest + fgs(nfgsp+il,k,it)**2
!                if(k.eq.k1.and.ibsp.eq.1) 
!     &         write(l6,*) 'fgs2(',nfgsp+il,k,it,')=',fgs(nfgsp+il,k,it)
                  enddo !il
                 enddo !ifg
!               write(*,*) 'stest=',stest
              enddo !k
          endif
        enddo !ib 
         kdsp(1,it)=klp1-kasp(1,it) 
         kasp(2,it)=klp1
!---- loop over K and parity-blocks
        do ib = 1,nb          
!-------------------------------------------------------------
!           kb(ib)>0 (positive parity);<0 (negative parity)
!-------------------------------------------------------------
         if(kb(ib).lt.0) then     
               ibsp = 2 
               k1 = ka(ib,it) + 1        
               k2 = ka(ib,it) + kd(ib,it) 
!---------- loop over S.P.States
            do k = k1,k2 
            klp1 = klp1+1
c            If(ib.eq.kkbloc(it).and.k.eq.kibloc(it)) then
c                kblocs(it) = klp1
c            endif
            vvs(klp1,it)=vvcan(k,it)
            ees(klp1,it)=eecan(k,it)
            delss(klp1,it)=decan(k,it)
!            fss(klp1,it)=fs(k,it)
!            eqps(klp1,it)=eqp(k,it)
              eqps(klp1,it)=dsqrt((eecan(k,it)-ala(it))**2
     &       +decan(k,it)**2) 
!------- loop over contributions from large and small components
            do ifg = 1,2
!-----------the block of spher. HO basis states 
            ndsp  = idsp(ibsp,ifg)
            i0sp  = iasp(ibsp,ifg)
            nfgsp = (ifg-1)*idsp(ibsp,1)
!---------- loop of spher. oscillator basis states------------
            do il=1,ndsp
            fgsph(nfgsp+il,klp1,it)=fgs(nfgsp+il,k,it)
            enddo !il
            enddo !ifg
            enddo !k
          endif
         enddo !ib
         kdsp(2,it)=klp1-kasp(2,it) 
         enddo !it
!------------------begin  test---------------------------------
!        do it = 1,2
!        do k=1,nk(it)
!        write(*,'(a,f15.8,a,f15.8)') 'sk=',sk(k),'sksp=',sksp(k)
!        enddo
!        pause
!        enddo 
!==============================================================
      if(lpr) then
      write(l6,140) '(  k,ib,it)  fg^2_{Cart.}  fg^2_{sph.}'
!---------- loop over neutrons and protons
       do it = 1,2
!---- loop over simplex-parity-blocks
!            do ib = 1,nb               
       do ibsp = 1,2               
               k1 = kasp(ibsp,it) + 1
               k2 = kasp(ibsp,it) + kdsp(ibsp,it)
!---------- loop over S.P.States
       do k = k1,k2
!----------------------------------------
            ormsphfg(k,ibsp,it)=0
!------- loop over contributions from large and small components
            do ifg = 1,2
!-----------the block of spher. HO basis states 
            ndsp  = idsp(ibsp,ifg)
            i0sp  = iasp(ibsp,ifg)
            nfgsp = (ifg-1)*idsp(ibsp,1)
!---------- loop of spher. oscillator basis states------------
            do il=1,ndsp 
!-----------------------------------
        ormsphfg(k,ibsp,it)=ormsphfg(k,ibsp,it)+fgsph(nfgsp+il,k,it)**2
!----------end loop of spher. oscillator basis states------------
            enddo !il
            enddo !ifg 
!         write(l6,*) '(', k,', ', ibsp,', ',it,')=',ormsphfg(k,ibsp,it)
!         write(*,*) '(', k,', ', ibsp,', ',it,')=',ormsphfg(k,ibsp,it)
       enddo !k
       enddo !ib
       enddo !it
       endif
!-------------------end test-----------------------------------
!==============================================================
!         open(33,file='rot.out',form='formatted',status='unknown')
!         do it =1,2
!         do ibsp = 1,2
!               k1 = kasp(ibsp,it) + 1        
!               k2 = kasp(ibsp,it) + kdsp(ibsp,it)
!              do k=k1,k2
!              do l=k1,k2
!              stest = 0
!                 do ifg =1,1
!                 ndsp  = idsp(ibsp,ifg)
!                 i0sp  = iasp(ibsp,ifg)
!                 nfgsp = (ifg-1)*idsp(ibsp,1)
!                 do il=1, ndsp
!                 stest = stest+fgsph(nfgsp+il,k,it)*fgsph(nfgsp+il,k,it)
!                 if(abs(fgsph(nfgsp+il,k,it)).gt.0.1) then
!                   write(33,*) it,ifg,ees(k,it),tb(k), fgsph(nfgsp+il,k,it), vvs(k,it), tts(i0sp+il),&
!             &  nljm(i0sp+il,1),nljm(i0sp+il,2),nljm(i0sp+il,3),nljm(i0sp+il,4) 
!                 endif
!                 enddo !il
!                 enddo !ifg
!                 if(k.ne.l.and.abs(stest).gt.0.000001) then
!                   print *,stest,tb(k),tb(l) 
!                   stop
!                 endif
!              enddo !l
!              enddo !k
!         enddo !ibsp
!         enddo !it
      if(lpr) 
     &write(l6,*) ' ******  END TRANSFORMATION*******************'
      return
!-end-TRISPH
      end
!===================================================================== 
!
      double precision function transsph(nz,nr,ml,ns,n,l,j,m) 
!===================================================================== 
!  m=ml+ns, ns=0 (down);1(up)
!  Transformation from cartesian oscillator with spin | ns >
!  to spherical oscillator |n s l j m> with spin | ms >
!
!---------------------------------------------------------------------
!
!  Use Definitions
!         Implicit None
!
      implicit real*8 (a-h,o-z)
      include 'dirhb.par'

         Integer m,ml,ns,nz,nr,n,l,j
         Real*8 external clebslj, cylsph
!
      transsph = 0.d0
!------------------------------------------------- 
      if(m.ne.ml+ns) return
!-------------------------------------------------  
      transsph = clebslj(l,j,ns,m)*cylsph(nz,nr,ml,n,l,ml) 
!------------------------------------------------- 
      return
!-end-TRANSSPH
      end
!
!=======================================================================
      
      double precision function clebslj(l,j,s,m)

!=======================================================================
!     s: the spin projection i.e. ms 
!     m: the total angular momentum projection i.e. m_j
!     Calculates  Clebsch-Gordan coefficients C(1/2,L,J,S,M-S,M)     
!     for integer L and half-integer j = J-1/2, ms = S-1/2
!
!-----------------------------------------------------------------------
!

!Use Definitions
c      Implicit None
      implicit real*8 (a-h,o-z)
      include 'dirhb.par'
!      
      Integer s,l,j,m
      common /gfvsq / sq(0:IGFV)
      common /gfvsqi/ sqi(0:IGFV)
!
      clebslj = 0.0d0
!
!     spin parallel orbital angular momentum
      if (j.eq.l+1) then
         if (s.eq.1) clebslj = sq(l+m)*sqi(2*l+1)
         if (s.eq.0) clebslj = sq(l-m+1)*sqi(2*l+1)
      endif
!
!     spin anti-parallel orbital angular momentum
      if (j.eq.l) then
         if (s.eq.1) clebslj = -sq(l-m+1)*sqi(2*l+1)
         if (s.eq.0) clebslj =  sq(l+m)*sqi(2*l+1)
      endif
!
      return
!-end-CLEBSLJ
      end
!      
!=======================================================================

      double precision function cylsph(nz,nr,ml,n,l,m) 
!=======================================================================
!
!     Transformation from cartesian oscillator to spherical oscillator
!
!     yields <nz, nr, ml | n, l, ml >  
!------------------------------------------------------
!     Ref.: R.R.Chasman and S. Wahlborn, NPA90(1967)401
!......................................................
!
!     | nz,nr,ml > = |nz> | nr,ml > exp( i ml phi )/sqrt(2 pi)
!
!       where | nr,ml > = sqrt( 2 nr! / (nr+|ml|)!) r_p ** |ml|
!                         *  L^|ml|_nr ( r_p**2 ) exp( - r_p**2/2)
!     np(olar) = 2*nr + |ml|
!......................................................
!
!     | n l m >  = sqrt( 2 (n-1)! / ( n+l-1/2)! ) r**l L^(l+1/2)_(n-1) (r**2)
!                  exp( -r**2/2 )  Y_lm (theta,phi)
!
!-----------------------------------------------------------------------
!
! Use Definitions
       Implicit None
!
       Integer nz,nr,ml,n,l,m,nn,nx,ny
       Real*8 c1,c2
       Real*8 carsph, carzyl
      cylsph = 0.d0
      if(ml.ne.m) return 
      nn = 2*(n-1) + l
!----------------------------------------------
      do nx=0,nn-nz
         ny=nn-nz-nx 
      c1 = carsph(nx,ny,nz,n,l,m)
      c2 = carzyl(nx,ny,nz,nz,nr,ml)
      if(c2.ne.0.d0) 
     &  cylsph = cylsph + c1*c2
      enddo !nx 
      return 
!=============================================
!
!    The following code is invalid now
!============================================
!-end-CYLSPH
      end 

!======================================================================
!
      double precision function carzyl(nx,ny,nz,nzz,nr,ml) 
!      
!======================================================================
!
!     Transformation from cartesian oscillator to zylindrical oscillator
!
!     yields <nx, ny, nz | nzz, nr, ml >  
!
!     | nx,ny,nz > = | nx > i**ny | ny > | nz >
!    
!       where | n > = pi**(-1/4) (2**n n!)**(-1/2) H_n(x) exp(-x**2/2)
!
!
!     | nz,nr,ml > = |nz> | nr,ml > exp( i ml phi )/sqrt(2 pi)
!
!       where | nr,ml > = sqrt( 2 nr! / (nr+|ml|)!) r_p ** |ml|
!                         *  L^|ml|_nr ( r_p**2 ) exp( - r_p**2/2)
!
!----------------------------------------------------------------------
!Use Definitions
!      Implicit None
!
      implicit real*8 (a-h,o-z)
      include 'dirhb.par'

c      real*8 carzyl
c      Integer Parameter igfvbc = 500
c      Integer nx,ny,nz,nzz,nr,ml,ma,np,k2
c      Real*8 s
!
      common /gfviv / iv(-IGFV:IGFV)
      common /gfvfibc/ fibc(0:IGFV,0:IGFV)
      common /gfvsqh/ sqh(0:IGFV)
      common /gfvwf / wf(0:IGFV)
      common /gfvwfi/ wfi(0:IGFV)

      carzyl = 0.d0
!
      if (nz.ne.nzz) return
      ma = iabs(ml)
      np = 2*nr + ma
      if (np.ne.nx+ny) return
!      if (np.ge.igfvbc) stop ' in CARZYL: igfvbc too small'
       if (np.ge.igfvbc) then
       write(77,*)'nx,ny,nz',nx,ny,nz,'  nzz,nr,ml',nzz,nr,ml
       write(77,*)'np',np,'igfvbc',igfvbc
       stop ' in CARZYL: igfvbc too small'
       endif
!
      s = 0.d0
      do k = 0,nr
         k2 = 2*k
         if (ny-ma.le.k2.and.k2.le.ny)   
     &      s = s + iv(k)*fibc(nr,k)*fibc(ma,ny-k2) 
      enddo
      carzyl = iv(nr)*sqh(0)**np*wf(nx)*wf(ny)*wfi(nr)*wfi(nr+ma)*s
      if (ml.lt.0) carzyl = iv(ny)*carzyl
!
      return
!-end-CARZYL
      end
!
!=====================================================================
!=======================================================================

      double precision function carsph(nx,ny,nz,n,l,m) 

!=======================================================================
!
!     Transformation from cartesian oscillator to spherical oscillator
!
!     yields <nx, ny, nzl | n, l, m >  
!
!......................................................
!
!     | nx,ny,nz > = | nx > i**ny | ny > | nz >
!    
!       where | n > = pi**(-1/4) (2**n n!)**(-1/2) H_N(x) exp(-x**2/2)
!
!......................................................
!
!     | n l m >  = sqrt( 2 (n-1)! / ( n+l-1/2)! ) r**l L^(l+1/2)_(n-1) (r**2)
!                  exp( -r**2/2 )  Y_lm (theta,phi)
!
!-----------------------------------------------------------------------
!
!Use Definitions
c      Implicit None
      implicit real*8 (a-h,o-z)
      include 'dirhb.par'
!
c      real*8 carsph
      Integer nx,ny,nz,n,l,m,ma,np,nr,nn,k2
      Real*8 s1,s2,aa,cc,zz

!
      common /mathco/ zero,one,two,half,third,pi
      common /gfviv / iv(-IGFV:IGFV)
      common /gfvfibc/ fibc(0:IGFV,0:IGFV)
      common /gfvfak/ fak(0:IGFV)
      common /gfvfad/ fad(0:IGFV)
      common /gfvsqh/ sqh(0:IGFV)
      common /gfvfi / fi(0:IGFV)
      common /gfvwf / wf(0:IGFV)

      carsph = zero
!
!      write(6,'(6i5)') nx,ny,nz,n,l,m
      ma = iabs(m)
      if(ma.gt.l) return
      np = nx + ny
      nr = np - ma
      if (nr.lt.0.or.mod(nr,2).ne.0) return
      nr = nr/2
      nn = 2*(n-1) + l
      if (nn.ne.nz+np) return
      if (nn.ge.igfvbc) stop ' in CARSPH: igfvbc too small'
!
      s1 = zero
      do k = 0,l
         if (2*k.ge.l+ma.and.k.lt.n+l) then   
!            write(6,*) k,n,l,ma,nr
            s1 = s1 + iv(k)*fibc(l,k)*fibc(2*k,l+ma)*fibc(n-1+l-k,nr) 
!         write(6,*) ' s1 =',k,s1
         endif
      enddo
!      write(6,*) 's1 ',s1
      s2 = zero
      do k = 0,nr
         k2 = 2*k
         if (ny-ma.le.k2.and.k2.le.ny)    
     &      s2 = s2 + iv(k)*fibc(nr,k)*fibc(ma,ny-k2) 
      enddo
!      write(6,*) 's2 ',s2
      aa = iv(n-1)*sqrt(2**(n+l+1)/(fak(n-1)*fad(n-1+l)))
      cc = iv(l-ma)*sqh(l)*wf(l+m)*wf(l-m)*fi(l)/2**l
      zz = wf(nx)*wf(ny)*wf(nz)*sqh(0)**(nn+1)
      carsph = aa*cc*zz*s1*s2
      if (m.lt.0) carsph = iv(ma+ny)*carsph
!
      return
!-end-CARSPH
      end 
